//
//  gvf.cpp
//
//  Created by Francisco on 04/05/2017.
//  Copyright © 2017 Goldsmiths. All rights reserved.
//

#include "rapidGVF.h"
#include "trainingData.h"


rapidGVF::rapidGVF()
{
    // Initialised with default configuration
    this->gvf = new GVF();
    this->currentGesture = GVFGesture();
}

rapidGVF::~rapidGVF()
{
    delete this->gvf;
    this->currentGesture = NULL;
}


bool rapidGVF::trainingData2GVF(const rapidmix::trainingData &newTrainingData, std::vector<std::vector<float>> &trainingSet) {
    
    if (newTrainingData.trainingSet.size() <= 1) {
        // no recorded phrase (only default one)
        return false;
    }
    
    if (newTrainingData.trainingSet.size() > 1 && newTrainingData.trainingSet[1].elements.size() == 0) {
        // empty recorded phrase
        return false;
    }
    
    //Go through every phrase
    for (int h = 0; h < newTrainingData.trainingSet.size(); ++h) {
        
        for (int i = 0; i < newTrainingData.trainingSet[h].elements.size(); ++i) {
        
            this->currentGesture.clear();
            std::vector<double> vd = newTrainingData.trainingSet[h].elements[i].input;
            
            // Using template <class InputIterator> vector to change for vec<double> to vec<float>
            std::vector<float> vf(vd.begin(), vd.end());
            this->currentGesture.addObservation(vf);
        }
        this->gvf->addGestureTemplate(this->currentGesture);
    }
    return true;
}

template<>
bool rapidmix::machineLearning<rapidGVF>::train(const trainingData &newTrainingData) {

    std::vector<std::vector<float>> trainingSet;
    trainingData2GVF(newTrainingData, trainingSet);
    return rapidGVF::train(trainingSet);
}

    
bool rapidGVF::train(const std::vector<std::vector<float>> &newTrainingData) {
    
//         vector<vector<float>> trainingData;
//    
//         for (vector<vector<vector<float>>>::iterator trainingGesture = trainingData.begin(); trainingGesture != trainingData.end(); trainingGesture++)
//         {
//         currentGesture.clear();
//         for (vector<vector<float>>::iterator frame = (*trainingGesture).begin(); frame != (*trainingGesture).end(); frame++)
//         {
//          Fill the template
//         currentGesture.addObservation(*frame);
//         }
//          Add the template at the end of the gesture
//         gvf->addGestureTemplate(currentGesture);
//         }
    
    return true;
}


template<>
std::vector<double> rapidmix::machineLearning<rapidGVF>::run(const std::vector<double> &inputVector) {

    return rapidGVF::process(inputVector);
}

std::vector<double> rapidGVF::process(const std::vector<double> &inputVector){
    
    gvf->restart();
    
    // Using template <class InputIterator> vector to change for vec<double> to vec<float>
    std::vector<float> vf(inputVector.begin(),inputVector.end());

    this->currentGesture.addObservation(vf);
    this->outcomes = this->gvf->update(this->currentGesture.getLastObservation());
   
    
    return std::vector<double>();
}










